import type React from 'react';
import type { ForwardRefComponent as PolymorphicForwardRefComponent } from '../utils/polymorphic';
type ElementProps = {
    as?: 'button';
    href?: never;
    /**
     * Specify whether the action is in a loading state.
     * Only available for button elements.
     */
    loading?: boolean;
} | {
    as: 'a';
    href: string;
    loading?: never;
};
export type ActionListTrailingActionProps = ElementProps & {
    icon?: React.ElementType;
    label: string;
    className?: string;
};
export declare const TrailingAction: PolymorphicForwardRefComponent<"button" | "a", ActionListTrailingActionProps>;
export {};
//# sourceMappingURL=TrailingAction.d.ts.map