import { c } from 'react-compiler-runtime';
import React from 'react';
import { clsx } from 'clsx';
import classes from './SkeletonBox.module.css.js';
import '@styled-system/css';
import merge from 'deepmerge';
import { jsx } from 'react/jsx-runtime';

const SkeletonBox = /*#__PURE__*/React.forwardRef(function SkeletonBox(t0, ref) {
  const $ = c(17);
  let className;
  let height;
  let props;
  let style;
  let width;
  if ($[0] !== t0) {
    ({
      height,
      width,
      className,
      style,
      ...props
    } = t0);
    $[0] = t0;
    $[1] = className;
    $[2] = height;
    $[3] = props;
    $[4] = style;
    $[5] = width;
  } else {
    className = $[1];
    height = $[2];
    props = $[3];
    style = $[4];
    width = $[5];
  }
  let t1;
  if ($[6] !== className) {
    t1 = clsx(className, classes.SkeletonBox);
    $[6] = className;
    $[7] = t1;
  } else {
    t1 = $[7];
  }
  const t2 = style;
  let t3;
  if ($[8] !== height || $[9] !== t2 || $[10] !== width) {
    t3 = merge(t2, {
      height,
      width
    });
    $[8] = height;
    $[9] = t2;
    $[10] = width;
    $[11] = t3;
  } else {
    t3 = $[11];
  }
  let t4;
  if ($[12] !== props || $[13] !== ref || $[14] !== t1 || $[15] !== t3) {
    t4 = /*#__PURE__*/jsx("div", {
      className: t1,
      style: t3,
      ...props,
      ref: ref
    });
    $[12] = props;
    $[13] = ref;
    $[14] = t1;
    $[15] = t3;
    $[16] = t4;
  } else {
    t4 = $[16];
  }
  return t4;
});

export { SkeletonBox };
