'use strict';

var reactCompilerRuntime = require('react-compiler-runtime');
var React = require('react');
var FeatureFlagContext = require('./FeatureFlagContext.js');

/**
 * Check if the given feature flag is enabled
 */
function useFeatureFlag(flag) {
  const $ = reactCompilerRuntime.c(3);
  const context = React.useContext(FeatureFlagContext.FeatureFlagContext);
  let t0;
  if ($[0] !== context || $[1] !== flag) {
    t0 = context.enabled(flag);
    $[0] = context;
    $[1] = flag;
    $[2] = t0;
  } else {
    t0 = $[2];
  }
  return t0;
}

exports.useFeatureFlag = useFeatureFlag;
