'use strict';

var reactCompilerRuntime = require('react-compiler-runtime');
var constants = require('../constants.js');
var _FormControlContext = require('./_FormControlContext.js');
var styled = require('styled-components');
var sx = require('../sx.js');
var jsxRuntime = require('react/jsx-runtime');

function _interopDefault (e) { return e && e.__esModule ? e : { default: e }; }

var styled__default = /*#__PURE__*/_interopDefault(styled);

const FormControlLeadingVisual = t0 => {
  const $ = reactCompilerRuntime.c(5);
  const {
    children,
    sx
  } = t0;
  const {
    disabled,
    captionId
  } = _FormControlContext.useFormControlContext();
  const t1 = disabled ? "" : undefined;
  const t2 = captionId ? "" : undefined;
  let t3;
  if ($[0] !== children || $[1] !== sx || $[2] !== t1 || $[3] !== t2) {
    t3 = /*#__PURE__*/jsxRuntime.jsx(StyledLeadingVisual, {
      "data-control-disabled": t1,
      "data-has-caption": t2,
      sx: sx,
      children: children
    });
    $[0] = children;
    $[1] = sx;
    $[2] = t1;
    $[3] = t2;
    $[4] = t3;
  } else {
    t3 = $[4];
  }
  return t3;
};
const StyledLeadingVisual = styled__default.default.div.withConfig({
  displayName: "FormControlLeadingVisual__StyledLeadingVisual",
  componentId: "sc-1c26i0t-0"
})(["--leadingVisual-size:", ";color:var(--fgColor-default);display:flex;align-items:center;&:where([data-control-disabled]){color:var(--control-fgColor-disabled);}& > *{min-width:var(--leadingVisual-size);min-height:var(--leadingVisual-size);fill:currentColor;}&:where([data-has-caption]){--leadingVisual-size:", ";}", ""], constants.get('fontSizes.2'), constants.get('fontSizes.4'), sx.default);

module.exports = FormControlLeadingVisual;
