'use strict';

var reactCompilerRuntime = require('react-compiler-runtime');
var InputValidation = require('../internal/components/InputValidation.js');
var _FormControlContext = require('./_FormControlContext.js');
var jsxRuntime = require('react/jsx-runtime');

const FormControlValidation = t0 => {
  const $ = reactCompilerRuntime.c(6);
  const {
    children,
    className,
    variant,
    sx,
    id
  } = t0;
  const {
    validationMessageId
  } = _FormControlContext.useFormControlContext();
  const t1 = id || validationMessageId || "";
  let t2;
  if ($[0] !== children || $[1] !== className || $[2] !== sx || $[3] !== t1 || $[4] !== variant) {
    t2 = /*#__PURE__*/jsxRuntime.jsx(InputValidation, {
      className: className,
      validationStatus: variant,
      id: t1,
      sx: sx,
      children: children
    });
    $[0] = children;
    $[1] = className;
    $[2] = sx;
    $[3] = t1;
    $[4] = variant;
    $[5] = t2;
  } else {
    t2 = $[5];
  }
  return t2;
};

module.exports = FormControlValidation;
