'use strict';

var reactCompilerRuntime = require('react-compiler-runtime');
var React = require('react');
var clsx = require('clsx');
var SkeletonBox_module = require('./SkeletonBox.module.css.js');
require('@styled-system/css');
var merge = require('deepmerge');
var jsxRuntime = require('react/jsx-runtime');

function _interopDefault (e) { return e && e.__esModule ? e : { default: e }; }

var React__default = /*#__PURE__*/_interopDefault(React);
var merge__default = /*#__PURE__*/_interopDefault(merge);

const SkeletonBox = /*#__PURE__*/React__default.default.forwardRef(function SkeletonBox(t0, ref) {
  const $ = reactCompilerRuntime.c(17);
  let className;
  let height;
  let props;
  let style;
  let width;
  if ($[0] !== t0) {
    ({
      height,
      width,
      className,
      style,
      ...props
    } = t0);
    $[0] = t0;
    $[1] = className;
    $[2] = height;
    $[3] = props;
    $[4] = style;
    $[5] = width;
  } else {
    className = $[1];
    height = $[2];
    props = $[3];
    style = $[4];
    width = $[5];
  }
  let t1;
  if ($[6] !== className) {
    t1 = clsx.clsx(className, SkeletonBox_module.SkeletonBox);
    $[6] = className;
    $[7] = t1;
  } else {
    t1 = $[7];
  }
  const t2 = style;
  let t3;
  if ($[8] !== height || $[9] !== t2 || $[10] !== width) {
    t3 = merge__default.default(t2, {
      height,
      width
    });
    $[8] = height;
    $[9] = t2;
    $[10] = width;
    $[11] = t3;
  } else {
    t3 = $[11];
  }
  let t4;
  if ($[12] !== props || $[13] !== ref || $[14] !== t1 || $[15] !== t3) {
    t4 = /*#__PURE__*/jsxRuntime.jsx("div", {
      className: t1,
      style: t3,
      ...props,
      ref: ref
    });
    $[12] = props;
    $[13] = ref;
    $[14] = t1;
    $[15] = t3;
    $[16] = t4;
  } else {
    t4 = $[16];
  }
  return t4;
});

exports.SkeletonBox = SkeletonBox;
