'use strict';

var reactCompilerRuntime = require('react-compiler-runtime');
var React = require('react');

function useEffectOnce(callback) {
  const $ = reactCompilerRuntime.c(2);
  const savedCallback = React.useRef(callback);
  const called = React.useRef(false);
  let t0;
  let t1;
  if ($[0] === Symbol.for("react.memo_cache_sentinel")) {
    t0 = () => {
      if (called.current === true) {
        return;
      }
      called.current = true;
      savedCallback.current();
    };
    t1 = [];
    $[0] = t0;
    $[1] = t1;
  } else {
    t0 = $[0];
    t1 = $[1];
  }
  React.useEffect(t0, t1);
}

exports.useEffectOnce = useEffectOnce;
